import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Munching squares. Places squares into the world according to the formula in placeSquare.
 */
public class MunchWorld extends World
{
    private static final int SIZE = 16;
    private int step = 1;
    
    /**
     * Create the world at the specified size.
     */
    public MunchWorld()
    {    
        super(SIZE, SIZE, 40); 
    }
    
    /**
     * Decide whether a square should be placed at the given location.
     */
    private boolean placeSquare(int x, int y)
    {
        return (x^y) < step;
    }
    
    public void act()
    {
        removeObjects(getObjects(null));    // remove all squares
        
        for (int y=0; y<SIZE; y++) {
            for (int x=0; x<SIZE; x++) {
                if ( placeSquare(x,y) ) {
                    addObject (new Square(), x, y);
                }
            }
        }

        step = (step % SIZE) + 1;       // count up
    }
}
